IdentityHashMap (FreeMarker 2.3.23 API)
Date: 2015-07-05

freemarker.ext.util

## Class IdentityHashMap

- java.lang.Object
- - java.util.AbstractMap
  - - freemarker.ext.util.IdentityHashMap

- All Implemented Interfaces:
    Serializable, Cloneable, Map

      public class IdentityHashMap
      extends AbstractMap
      implements Map, Cloneable, Serializable

  A variant of `HashMap` that uses `System.identityHashCode(Object)` for hashing, and reference comparison instead of `Object.equals(Object)`. Note that this applies only to keys, and not to values, i.e. `containsValue(Object)` still uses `Object.equals(Object)`.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.util.AbstractMap

      `AbstractMap.SimpleEntry<K,V>, AbstractMap.SimpleImmutableEntry<K,V>`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static long` | `serialVersionUID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IdentityHashMap()` Constructs a new, empty map with a default capacity and load factor, which is `0.75`.
    `IdentityHashMap(int initialCapacity)` Constructs a new, empty map with the specified initial capacity and default load factor, which is `0.75`.
    `IdentityHashMap(int initialCapacity, float loadFactor)` Constructs a new, empty map with the specified initial capacity and the specified load factor.
    `IdentityHashMap(Map t)` Constructs a new map with the same mappings as the given map.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Removes all mappings from this map.
    `Object` | `clone()` Returns a shallow copy of this `IdentityHashMap` instance: the keys and values themselves are not cloned.
    `boolean` | `containsKey(Object key)` Returns `true` if this map contains a mapping for the specified key.
    `boolean` | `containsValue(Object value)` Returns `true` if this map maps one or more keys to the specified value.
    `Set` | `entrySet()` Returns a collection view of the mappings contained in this map.
    `Object` | `get(Object key)` Returns the value to which this map maps the specified key.
    `boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
    `Set` | `keySet()` Returns a set view of the keys contained in this map.
    `Object` | `put(Object key, Object value)` Associates the specified value with the specified key in this map.
    `void` | `putAll(Map t)` Copies all of the mappings from the specified map to this one.
    `Object` | `remove(Object key)` Removes the mapping for this key from this map if present.
    `int` | `size()` Returns the number of key-value mappings in this map.
    `Collection` | `values()` Returns a collection view of the values contained in this map.

    - ### Methods inherited from class java.util.AbstractMap

      `equals, hashCode, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, equals, forEach, getOrDefault, hashCode, merge, putIfAbsent, remove, replace, replace, replaceAll`

- - ### Field Detail

    - #### serialVersionUID

          public static final long serialVersionUID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### IdentityHashMap

          public IdentityHashMap(int initialCapacity,
                                 float loadFactor)

      Constructs a new, empty map with the specified initial capacity and the specified load factor.
      Parameters:
        `initialCapacity` - the initial capacity of the IdentityHashMap.
        `loadFactor` - the load factor of the IdentityHashMap
      Throws:
        `IllegalArgumentException` - if the initial capacity is less than zero, or if the load factor is nonpositive.

    - #### IdentityHashMap

          public IdentityHashMap(int initialCapacity)

      Constructs a new, empty map with the specified initial capacity and default load factor, which is `0.75`.
      Parameters:
        `initialCapacity` - the initial capacity of the IdentityHashMap.
      Throws:
        `IllegalArgumentException` - if the initial capacity is less than zero.

    - #### IdentityHashMap

          public IdentityHashMap()

      Constructs a new, empty map with a default capacity and load factor, which is `0.75`.

    - #### IdentityHashMap

          public IdentityHashMap(Map t)

      Constructs a new map with the same mappings as the given map. The map is created with a capacity of twice the number of mappings in the given map or 11 (whichever is greater), and a default load factor, which is `0.75`.
      Parameters:
        `t` - the map whose mappings are to be placed in this map.

  - ### Method Detail

    - #### size

          public int size()

      Returns the number of key-value mappings in this map.
      Specified by:
        `size` in interface `Map`
      Overrides:
        `size` in class `AbstractMap`
      Returns:
        the number of key-value mappings in this map.

    - #### isEmpty

          public boolean isEmpty()

      Returns `true` if this map contains no key-value mappings.
      Specified by:
        `isEmpty` in interface `Map`
      Overrides:
        `isEmpty` in class `AbstractMap`
      Returns:
        `true` if this map contains no key-value mappings.

    - #### containsValue

          public boolean containsValue(Object value)

      Returns `true` if this map maps one or more keys to the specified value.
      Specified by:
        `containsValue` in interface `Map`
      Overrides:
        `containsValue` in class `AbstractMap`
      Parameters:
        `value` - value whose presence in this map is to be tested.
      Returns:
        `true` if this map maps one or more keys to the specified value.

    - #### containsKey

          public boolean containsKey(Object key)

      Returns `true` if this map contains a mapping for the specified key.
      Specified by:
        `containsKey` in interface `Map`
      Overrides:
        `containsKey` in class `AbstractMap`
      Parameters:
        `key` - key whose presence in this Map is to be tested.
      Returns:
        `true` if this map contains a mapping for the specified key.

    - #### get

          public Object get(Object key)

      Returns the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key. A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.
      Specified by:
        `get` in interface `Map`
      Overrides:
        `get` in class `AbstractMap`
      Parameters:
        `key` - key whose associated value is to be returned.
      Returns:
        the value to which this map maps the specified key.

    - #### put

          public Object put(Object key,
                            Object value)

      Associates the specified value with the specified key in this map. If the map previously contained a mapping for this key, the old value is replaced.
      Specified by:
        `put` in interface `Map`
      Overrides:
        `put` in class `AbstractMap`
      Parameters:
        `key` - key with which the specified value is to be associated.
        `value` - value to be associated with the specified key.
      Returns:
        previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the IdentityHashMap previously associated `null` with the specified key.

    - #### remove

          public Object remove(Object key)

      Removes the mapping for this key from this map if present.
      Specified by:
        `remove` in interface `Map`
      Overrides:
        `remove` in class `AbstractMap`
      Parameters:
        `key` - key whose mapping is to be removed from the map.
      Returns:
        previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the map previously associated `null` with the specified key.

    - #### putAll

          public void putAll(Map t)

      Copies all of the mappings from the specified map to this one. These mappings replace any mappings that this map had for any of the keys currently in the specified Map.
      Specified by:
        `putAll` in interface `Map`
      Overrides:
        `putAll` in class `AbstractMap`
      Parameters:
        `t` - Mappings to be stored in this map.

    - #### clear

          public void clear()

      Removes all mappings from this map.
      Specified by:
        `clear` in interface `Map`
      Overrides:
        `clear` in class `AbstractMap`

    - #### clone

          public Object clone()

      Returns a shallow copy of this `IdentityHashMap` instance: the keys and values themselves are not cloned.
      Overrides:
        `clone` in class `AbstractMap`
      Returns:
        a shallow copy of this map.

    - #### keySet

          public Set keySet()

      Returns a set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice versa. The set supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
      Specified by:
        `keySet` in interface `Map`
      Overrides:
        `keySet` in class `AbstractMap`
      Returns:
        a set view of the keys contained in this map.

    - #### values

          public Collection values()

      Returns a collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice versa. The collection supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
      Specified by:
        `values` in interface `Map`
      Overrides:
        `values` in class `AbstractMap`
      Returns:
        a collection view of the values contained in this map.

    - #### entrySet

          public Set entrySet()

      Returns a collection view of the mappings contained in this map. Each element in the returned collection is a `Map.Entry`. The collection is backed by the map, so changes to the map are reflected in the collection, and vice versa. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
      Specified by:
        `entrySet` in interface `Map`
      Specified by:
        `entrySet` in class `AbstractMap`
      Returns:
        a collection view of the mappings contained in this map.
      See Also:
        `Map.Entry`